/*
{
    "author": "",
    "color": "blue",
    "movement": true,
    "parameters": [
		{
			"default": 0.5,
			"name": "x"
		},
		{
			"default": 0.5,
			"name": "y"
		},
        {
            "default": 0.3,
            "name": "m"
        },
		{
			"default": 0.5,
			"name": "g"
		}
    ],
    "url": "http://glslsandbox.com/e#45602.0",
    "uuid": "98276951-c254-47ee-b6d8-e5fcc37e4ec2"
}
*/

#ifdef GL_ES
precision highp float;
#endif

//uniform float time;
//uniform vec2 mouse;
//uniform vec2 resolution;

void main( void ) {
	float div = resolution.x / resolution.y;
	vec2 aspect = vec2(1., div);
	vec2 position = texCoord*aspect-vec2(0.5*x, 0.5*y*div);
    //vec2 position = ( gl_FragCoord.xy / resolution.x ) + mouse / 4.0;

    float c = 0.0;
    c += sin( position.x * cos( time / 15.0 ) * 80.0 ) + cos( position.y * cos( time / 15.0 ) * 10.0 );
    c += sin( position.y * sin( time / 10.0 ) * 40.0 ) + cos( position.x * sin( time / 25.0 ) * 40.0 );
    c += sin( position.x * sin( g*time / 5.0 ) * 10.0 ) + sin( position.y * sin( m*time / 35.0 ) * 80.0 );
    c *= sin( time / 10.0 ) * 0.5;
	
    gl_FragColor = vec4( vec3( c, c * color.r*opacity, sin( c*color.rgb*opacity + time / 3.0 ) * 0.75 ), alpha );

}
