/*
{
    "author": "",
    "color": "blue",
    "movement": true,
    "parameters": [
		{
			"default": 0.5,
			"name": "x"
		},
		{
			"default": 0.5,
			"name": "y"
		},
		{
			"default": 0.5,
			"name": "mouse"
		}
    ],
    "url": "",
    "uuid": "23ff6d14-8512-4b7b-9321-e4a0b6cadf55"
}
*/

#ifdef GL_ES
precision highp float;
#endif

#define rot(a) mat2(cos(a), sin(a), -sin(a), cos(a))
const float TAU = atan(1.0) * 8.0;
#define A(u,w) 	k=length(p.xy);p.x=k*(mod(atan(p.y,p.x),TAU/u)-TAU/u/2.);p.y=k-w		
#define B(u,w) 	k=length(p.yz);p.y=k*(mod(atan(p.z,p.y),TAU/u)-TAU/u/2.);p.z=k-w		
#define C(u,w) 	k=length(p.yz);p.y=k*abs(sin(atan(p.z,p.y))-.5)*TAU/u;p.z=k-w		

vec3 map(vec3 p, float u, float v) {
	float k;
	p.xy *= rot(u);
	p.yz *= rot(v);
		
	A(10.,0.);   // 0 here makes a sphere, easier to control color according to p
	B(12.,10.);
	A(10.,2.7); //A(18.,.7); 
	C(12.,10.0);
	A(10.,2.7); 
	B(12.,-5.7);
	A(10.,1.97); // 1.97+.05*cos(p.z*20.-time*8.)
	B(12.,10.5);
	A(16.,2.7); //10,2.7
	B(12.,-10.);
	A(10.,2.7); 
	B(12.,10.);
	
	p.x = dot(abs(p), normalize(vec3(6.9,5,2.2))) - 1.6 ;
	return p; 
}

void main( void ) {
	float div = resolution.x/resolution.y;
	vec2 aspect = vec2(1.,div);
	vec2 uv = texCoord*aspect-vec2(0.5,y*div);

	//vec2 uv = (gl_FragCoord.xy - 0.5 * resolution) / resolution.y;
	vec3 rd = normalize(vec3(uv, 1));
	float v=-8.*mod(time/66.,TAU), u=mouse+.25, c=.11; 
	vec3 p = vec3(0, (45.+25.*mouse)*c+3., -5.25*c-3.); // +-171.+262.*mouse  <- y term
	vec3 col = vec3(0);
	for (float i = 1.; i < 160.; i++) {
		vec3 d = map(p, u, v); 			
		if (d.x < 0.001) {
			//float x=max(0.,length(p)-11.7)*300.;
			//gl_FragColor = vec4( 144.-x*20.,100.+x,80.-x*200.,100)/float(4*i*i);			
			float x=max(0.,length(p)-12.)*400.;
			col = vec3(144.-x,100.+x,80.-x)/(i*i);			
			break;
		}
		p += rd * d.x;
	}
	gl_FragColor=vec4(col*color.rgb*opacity,alpha);
}
