/*
{
    "author": "",
    "color": "pink",
    "movement": true,
    "parameters": [
		{
			"default": 0.5,
			"name": "x"
		},
		{
			"default": 0.5,
			"name": "y"
		},
		{
			"default": 0.2,
			"name": "arf",
			"min": 0.1
		},
		{
			"default": 0.3,
			"name": "arq",
			"min": 0.1
		}
    ],
    "url": "",
    "uuid": "bcf57789-69d8-46c8-8667-9f7123d4dbf1"
}
*/

#ifdef GL_ES
precision highp float;
#endif


void main( void ) {
	float div = resolution.x/resolution.y;
	vec2 aspect = vec2(1.,div);
	vec2 p = texCoord*aspect-vec2(0.5, 0.5*div);

	//vec2 p = 2.0*( gl_FragCoord.xy / resolution.xy ) + mouse - 1.5;
	vec3 col = vec3(0);
	
	col += vec3(1)*1.0/(1.0+50.0*abs(p.y+sin(p.x*10.0)*cos(time*2.))); 
	col += vec3(1)*1.0/(1.0+(50.0*arq)*abs(p.y+sin(p.x*10.0+3.1415)*cos(time*arf))); 
	gl_FragColor = vec4(col*color.rgb*opacity, 1.0);
}
