/*
{
    "author": "",
    "color": "#blue",
    "movement": true,
    "parameters": [
		{
			"default": 0.5,
			"name": "x"
		},
		{
			"default": 0.5,
			"name": "y"
		},
		{
			"default": 0.0,
			"name": "gorp"
		},
		{
			"default": 1.0,
			"name": "trip"
		}
    ],
    "url": "",
    "uuid": "3cfaae7b-38ef-45e8-8828-ea764980a20e"
}
*/

#ifdef GL_ES
precision highp float;
#endif

//uniform vec2 resolution;
//uniform float time;

void main() {
	float div = resolution.x/resolution.y;
	vec2 aspect = vec2(1.,div);
	vec2 p = texCoord*aspect-vec2(x,y*div);

    //vec2 p = -1.0 + 2.0 * gl_FragCoord.xy / resolution.xy;

    int size = 2 * int(min(resolution.x, resolution.y) / trip);

    float t = sin(time + distance(p, vec2(0.)));

    vec2 tailoff = vec2(float(size) / (1.0 + sin(t)),
        tan((t - sin(t)) * 6.283185307179586476925286766559));

    gl_FragColor = vec4(sin(length(p - tailoff)), cos(length(p - tailoff)), sin(length(p)), 1.0);
}
