/*
{
    "author": "",
    "color": "lightpink",
    "movement": true,
    "parameters": [
		{
			"default": 0.5,
			"name": "x"
		},
		{
			"default": 0.5,
			"name": "y"
		},
		{
			"default": 0.5,
			"name": "flur",
			"min": 0.3
		},
		{
			"default": 1.0,
			"name": "bye"
		}
    ],
    "url": "",
    "uuid": "a2490bf3-456d-47d4-a6ff-114da8fc7794"
}
*/

#ifdef GL_ES
precision highp float;
#endif

mat2 rotate2D(float r){
    return mat2(cos(r), sin(r), -sin(r), cos(r));
}

vec3 camPath(float time) {
    vec2 p = 600.0 * vec2(sin(1.4 + 0.37 * time),cos(3.2 + 0.31 * time));
    return vec3(p.x, 0.0, p.y);
}


float city(vec2 FC, vec2 r, float t) {
    float e=0.0,l=0.0,y=0.0,o=0.0;
    vec3 p,q;
	
	vec3 d=vec3((FC.xy-.5*r)/r.y,-1);
   
   d.xz *=rotate2D(t*.2);
	
	
    e=max(min(++y,-e),y-3.);
	
    for(float i=0.0;i<2e2;i++) {
        i>1e2?l=log(e+=1e-4)/1e2,d/=d,o:o+=exp(-e*1e3)/2e2;
	p=q+=d*e*.7;
        p++;
        y=p.y*bye;
        for (float a2 = 0.; a2 < 9.; ++a2) {
            float a = 3. * pow(.6, a2);
            p.xz*=rotate2D(5.);
            p=abs(p)-a;
            e=min(e,max(p.x,(max(p.y,p.z))));
	}
        e=max(min(++y,-e),y-3.);
    }
    o+=l;
    return o/flur;
}

vec3 postprocess(vec2 uv,vec3 col){
    
	col.gb *=  uv.y * .6; 
	col.g = 0.0+0.6*smoothstep(-0.1,0.9,col.g*2.0);
	col = 0.001+pow(col, vec3(1.2))*1.5;
	//col = clamp(1.06*col-0.03, 0., 1.);   
        col *= mod(gl_FragCoord.y, 4.0)<2.0 ? 0.6 : 1.0;

	return col;
}

void main( void ) {
	float div = resolution.x/resolution.y;
	vec2 aspect = vec2(1.,div);
	vec2 uv = texCoord/aspect-vec2(x,y/div);

	//vec2 uv = ( gl_FragCoord.xy / resolution.xy );
	
	//float c = city(resolution.xy, resolution.xy, time);
	float c = city(gl_FragCoord.xy, resolution.xy, time);
	
	vec3 final =  vec3(c);
	
	final = postprocess(uv,final);

	gl_FragColor = vec4(c*color.rgb*opacity, alpha);

}


