/*
{
    "author": "",
    "color": "blue",
    "movement": true,
    "parameters": [
		{
			"default": 0.5,
			"name": "x"
		},
		{
			"default": 0.5,
			"name": "y"
		},
		{
			"default": 0.5,
			"name": "mouse"
		},
		{
			"default": 0.5,
			"name": "sneez"
		},
		{
			"default": 0.1,
			"name": "inp"
		}
    ],
    "url": "",
    "uuid": "42026fc4-8a22-4676-bcba-d85a8ef72b6c"
}
*/

#ifdef GL_ES
precision mediump float;
#endif

//uniform float time;
//uniform vec2 mouse;
//uniform vec2 resolution;

#define N 40
#define PI2 (3.14159265*2.0)
void main( void ) {
	float div = resolution.x/resolution.y;
	vec2 aspect = vec2(1.,div);
	vec2 v = texCoord*aspect-vec2(x, y*div);

	//vec2 v = (gl_FragCoord.xy - resolution/2.0) / min(resolution.y,resolution.x) * 15.0;

	
	float t = time * 9.5;

	float factor = (mouse*sneez) * 1.12;
	float c = cos(mouse * PI2);
	float s = sin((mouse/sneez) * PI2);
	
	
	for ( int i = 1; i <= N; i++ ){
		float d = float(i+3) / float(N);
		float x = v.x;
		float y = v.y + sin(v.x * d * 3.0 + t*inp)/d*factor + cos(v.x * d + t)/d*factor;
		
		v.x = x * c - y * s;
		v.y = x * s + y * (c*inp);

	}
	float col = length(v)*0.25;
	gl_FragColor = vec4(( cos(col + time)), cos(col-1.0+(time)), cos(col*8.0), color.rgb*opacity*alpha );

}
