/*
{
    "author": "",
    "color": "#111111",
    "movement": true,
    "parameters": [
        {
            "default": 0.3,
            "name": "x"
        },
        {
            "default": 0.3,
            "name": "y"
        },
        {
            "default": 0.3,
            "name": "mouse"
        },
        {
            "default": 0.3,
            "name": "move"
        }
        
    ],
    "url": "",
    "uuid": "82860024-2f16-48f4-b58a-7520f493691c"
}
*/

#ifdef GL_ES
precision highp float;
#endif

 

 
float random(vec2 co){
    return fract(sin(dot(co, vec2(12.9898, 78.233))) * 43758.5453);
}
 
vec3 scouse(vec2 p) {
    vec3 p3 = vec3(p*move + random(p.xy) - .5, time * move);
 
    for (int i = 0; i < 50; i++) {
        p3.xzy = abs(((p3) / dot(p3, p3) - vec3(1.0, 1.0, mouse * 0.5)));
    }
 
    return cos(p3.xzy);
}
 
void main() {

    float div = resolution.y/resolution.x;
    vec2 aspect = vec2(1.,div);
    vec2 p = texCoord*aspect-vec2(x,y*div);
   // vec2 p = (gl_FragCoord.xy - resolution * 0.5) / 300.; // OG resolution
 
    vec3 d = scouse(p);
 
    if (length(d) > 0.) {
        float n = dot(d, d);
        d *= 1. / n;
 
        vec3 center = vec3(0., 0.5, 0.);
 
        vec3 v = fract(vec3(p.x, 0., p.y) + center);
 
        vec3 dt = d / 10.;
 
        for (int i = 0; i < 50; i++) {
            int j = i * 4;
            float t = float(j) / 50.;
 
            v = fract(v + 2./n * center + t * dt);
        }
 
        gl_FragColor = vec4(v*color.rgb*opacity, alpha*1.);
    } else {
        gl_FragColor = vec4(color.rgb*opacity*scouse(p), alpha);
    }
}